**Vixeny**

<p align="center">
  <img src="misc/logo.png" alt="Vixeny Logo" style="max-width: 100%;">
  <br>
  <b style="font-size:1.2em; font-style:italic; color:darkcyan;">Harness the Power of Pure Functionality</b>
  <br>
  <a href="https://vixeny.dev/">Website</a>
</p>

**Introducing Vixeny: A New Era in Web Development**

🌍 A performance-centric, runtime-agnostic library and framework designed for
purity, immutability, and controlled effects. Whether you're deep diving into
functional paradigms or balancing them with others, Vixeny offers the
flexibility and robustness web developers need.

- **Unmatched Speed**: Experience the fastest framework in the Deno ecosystem.
- **DRY and Functional**: Designed with the principles of DRY (Don't Repeat
  Yourself) and advanced functional programming, including naitve mocking and
  code isolation.
- **Zero-Dependency Architecture**: Lean and efficient, with a focus on
  simplicity and performance.
- **Native Plugin Support**: Enhance functionality with ease using native
  plugins.
- **Robust Security**: Predictable and deterministc.
- **Advanced Type Checking**: Ensures safe, predictable code.
- **Versatile Paradigms**: Supports functional programming and other paradigms
  in a cohesive manner.
- **Object-Oriented**: Facilitates easy code manipulation and maintenance.
- **Test-Friendly**: Framework designed to be easily testable, end to end.
- **Future-Proof**: Stay ahead in web development with Vixeny's innovative
  features.

**Start your journey with Vixeny – redefine efficiency and innovation in web
development.**

[Website](https://vixeny.dev/)

**Benchmarks**

- [JWT Benchmark](https://github.com/mimiMonads/FrameworkBench)
- [Bun by SaltyAom](https://github.com/SaltyAom/bun-http-framework-benchmark)

**License:**
[CC BY-ND 4.0](https://creativecommons.org/licenses/by-nd/4.0/legalcode.txt)
